


--------------------------------------------------------------------------------------------------------------------------------
-- step 1: create unknown sim regular table
--------------------------------------------------------------------------------------------------------------------------------

if exists (select name from sysobjects
   where name='orangebills_regular_unknown_temp' and type='U')
   drop table orangebills_regular_unknown_temp

select cc.sim, cc.startyear, cc.startmonth, cc.endyear, cc.endmonth, aa.total_mb into orangebills_regular_unknown_temp
from 
-- this is to make sure all sim-bill_period will appear
	(
		select sim, startyear, startmonth, endyear, endmonth
		from orange_billing_period_view, unknown_sim_view
	) cc
	left outer join
	(
		select sim, startyear, startmonth, endyear, endmonth, sum(total_mb+roaming_mb) as total_mb
		from orange_billing_period_view b,orangebills a
		where
		(
		tariff_start >= 
			convert(datetime,			
				convert(char(4),startyear)  +'-'+
				convert(char(4),startmonth) +'-'+
				convert(char(4),startday)			
			    )
		and 
		tariff_end<=
			convert(datetime,			
				convert(char(4),endyear)  +'-'+
				convert(char(4),endmonth) +'-'+
				convert(char(4),endday)			
				
			    )
		)
		--where sim in (select sim from unknown_sim_serialid_view_temp)
		group by sim, startyear, startmonth,startday,endyear, endmonth,endday
		
		--order by sim, startyear, startmonth, endyear, endmonth
	) aa
on cc.startyear=aa.startyear and cc.startmonth=aa.startmonth and cc.endyear=aa.endyear
and cc.endmonth=aa.endmonth and cc.sim=aa.sim



--------------------------------------------------------------------------------------------------------------------------------
-- step 2: make sure there is no null value
--------------------------------------------------------------------------------------------------------------------------------

update orangebills_regular_unknown_temp 
set total_mb=0.0
where total_mb is null



--------------------------------------------------------------------------------------------------------------------------------
-- step 3: calculate increasing percentage
--------------------------------------------------------------------------------------------------------------------------------
if exists (select name from sysobjects
   where name='orangebills_regular_unknown_percent_temp' and type='U')
   drop table orangebills_regular_unknown_percent_temp



select aa.sim, aa.startyear, aa.startmonth, bb.total_mb, thisMonthIncrease
into orangebills_regular_unknown_percent_temp
from
orangebills_regular_unknown_temp bb,

(

	select 
		a.sim, a.startyear, a.startmonth,(a.total_mb-b.total_mb)/b.total_mb as thisMonthIncrease
	from 
		orangebills_regular_unknown_temp a, orangebills_regular_unknown_temp b
	where 
		a.sim =b.sim 
		and 
		(
			(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
			or
			(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
		)
		and
		b.total_mb is not null
		and b.total_mb<>0.0 

union

	select distinct sim, 2007 as startyear, 9 as startmonth, 1.0 as thisMonthIncrease
	from orangebills_regular_unknown_temp 
	
	where startyear=2007 and startmonth=9
	
	union
	
	select a.sim, a.startyear, a.startmonth,0.0 as thisMonthIncrease
	from orangebills_regular_unknown_temp a, orangebills_regular_unknown_temp b
	where a.sim =b.sim 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb=0.0

union

	select a.sim, a.startyear, a.startmonth,1.0 as thisMonthIncrease
	from
		orangebills_regular_unknown_temp a, orangebills_regular_unknown_temp b
	where a.sim =b.sim 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb<>0.0
	
) aa

where aa.sim =bb.sim and aa.startyear=bb.startyear and aa.startmonth= bb.startmonth







--------------------------------------------------------------------------------------------------------------------------------
-- The following known sim regular table is for demo and testing purpose!!!
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- The following known sim regular table is for demo and testing purpose!!!
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- The following known sim regular table is for demo and testing purpose!!!
--------------------------------------------------------------------------------------------------------------------------------



--------------------------------------------------------------------------------------------------------------------------------
-- step 1: create known sim regular table
--------------------------------------------------------------------------------------------------------------------------------

if exists (select name from sysobjects
   where name='orangebills_regular_known_temp' and type='U')
   drop table orangebills_regular_known_temp

select cc.sim, cc.startyear, cc.startmonth, cc.endyear, cc.endmonth, aa.total_mb into orangebills_regular_known_temp
from 
-- this is to make sure all sim-bill_period will appear
	(
		select sim, startyear, startmonth, endyear, endmonth, 0 as total_mb
		from orange_billing_period_view, known_sim_view
	) cc
	left outer join
	(
		select sim,startyear, startmonth, endyear, endmonth, sum(total_mb+roaming_mb) as total_mb
		from orange_billing_period_view b,orangebills a
		where
		(
		tariff_start >= 
			convert(datetime,			
				convert(char(4),startyear)  +'-'+
				convert(char(4),startmonth) +'-'+
				convert(char(4),startday)			
			    )
		and 
		tariff_end<=
			convert(datetime,			
				convert(char(4),endyear)  +'-'+
				convert(char(4),endmonth) +'-'+
				convert(char(4),endday)			
				
			    )
		)
		
		group by sim, startyear, startmonth,startday,endyear, endmonth,endday
		
		--order by sim, startyear, startmonth, endyear, endmonth
	) aa
on cc.startyear=aa.startyear and cc.startmonth=aa.startmonth and cc.endyear=aa.endyear
and cc.endmonth=aa.endmonth and cc.sim=aa.sim



--------------------------------------------------------------------------------------------------------------------------------
-- step 2: make sure there is no null value
--------------------------------------------------------------------------------------------------------------------------------

update orangebills_regular_known_temp 
set total_mb=0.0
where total_mb is null



--------------------------------------------------------------------------------------------------------------------------------
-- step 3: calculate increasing percentage
--------------------------------------------------------------------------------------------------------------------------------
if exists (select name from sysobjects
   where name='orangebills_regular_known_percent_temp' and type='U')
   drop table orangebills_regular_known_percent_temp



select aa.sim, aa.startyear, aa.startmonth, bb.total_mb, thisMonthIncrease
into orangebills_regular_known_percent_temp
from
orangebills_regular_known_temp bb,

(

	select 
		a.sim, a.startyear, a.startmonth,(a.total_mb-b.total_mb)/b.total_mb as thisMonthIncrease
	from 
		orangebills_regular_known_temp a, orangebills_regular_known_temp b
	where 
		a.sim =b.sim 
		and 
		(
			(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
			or
			(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
		)
		and
		b.total_mb is not null
		and b.total_mb<>0.0 

union

	select distinct sim, 2007 as startyear, 9 as startmonth, 1.0 as thisMonthIncrease
	from orangebills_regular_known_temp 
	
	where startyear=2007 and startmonth=9
	
	union
	
	select a.sim, a.startyear, a.startmonth,0.0 as thisMonthIncrease
	from orangebills_regular_known_temp a, orangebills_regular_known_temp b
	where a.sim =b.sim 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb=0.0

union

	select a.sim, a.startyear, a.startmonth,1.0 as thisMonthIncrease
	from
		orangebills_regular_known_temp a, orangebills_regular_known_temp b
	where a.sim =b.sim 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb<>0.0
	
) aa

where aa.sim =bb.sim and aa.startyear=bb.startyear and aa.startmonth= bb.startmonth


